# Examples

## Callbacks

### Post Shopping Cart Checkout Callback

Here is an example of creating a callback for a payment gateway to create a payment. The conditions need to be met.

```
 $callbackId = $retailysService->postShoppingCartCheckoutCallback($token, [
                    'position' => 'payment',
                    'path' => 'create-payment',
                    'method' => 'POST',
                    'redirect' => true,
                    'parameters' => [
                        [
                            'name' => 'orderId',
                            'variable' => '%orderId%',
                        ],
                        [
                            'name' => 'channelId',
                            'variable' => '%channelId%',
                        ],
                    ],
                    'condition' => '%channelId% == '.$existingChannel->getChannelId().' and %paymentProvider% == 9',
                ]);
```

{% hint style="info" %}
Endpoint  [/System/Layouts/Eshop/ShoppingCart/Checkout/Callbacks](https://api.retailys.com/v1#/System.Layouts.Eshop/postEshopShoppingCartCheckoutCallbacks) to an API where you can easily try it out.
{% endhint %}

## View rendering

Here is an example of how to render a view into which variables are inserted so that we can use them in the template. The snippet is here returned in JSON.

```
$snippet = $this->renderView('config/save.html.twig', [
            'config' => $config,
            'channelsData' => $channelsData,
            'configChannels' => $configChannels,
        ]);

        return $this->json(
            [
                'snippet' => $snippet,
            ]
        );
```

## Snippets

### Static Snippet

#### Post Layout

Create a static snippet in eshop layout

```
$snippetId = $retailysService->postLayoutStaticSnippet($token, [
                    'position' => 'footer',
                    'raw' => $this->renderView('snippet/variable.html.twig', [
                        'variable' => $channel->getVariable(),
                    ]),
                    'condition' => '%channelId% == '.$channel->getChannelId(),
                ]);
```

{% hint style="info" %}
Endpoint [/System/Layouts/Eshop/Layout/StaticSnippets](https://api.retailys.com/v1#/System.Layouts.Eshop/postEshopLayoutStaticSnippets) to an API where you can easily try it out.
{% endhint %}

#### Put Layout

Update a static snippet in eshop layout

```
$snippetResult = $retailysService->putLayoutStaticSnippet($token, [
                    'id' => $channel->getSnippetId(),
                    'position' => 'footer',
                    'raw' => $this->renderView('snippet/variable.html.twig', [
                        'variable' => $channel->getVariable(),
                    ]),
                    'condition' => '%channelId% == '.$channel->getChannelId(),
                ]);
```

{% hint style="info" %}
Endpoint [/System/Layouts/Eshop/Layout/StaticSnippets](https://api.retailys.com/v1#/System.Layouts.Eshop/putEshopLayoutStaticSnippets) to an API where you can easily try it out.
{% endhint %}

### Dynamic Snippet

#### Post dynamic snippet into shopping cart on thank you page

```
$dynamicSnippetId = $retailysService->postShippingCartThankYouDynamicSnippet($token, [
                        'position' => 'footer',
                        'type' => 'twig',
                        'template' => $this->renderView('snippet/example.html.twig', [
                          'variable' => $channel->getVariable(),
                        ]),
                        'condition' => '%channelId% == '.$channel->getChannelId(),
                    ]);
```

{% hint style="info" %}
Endpoint [/System/Layouts/Eshop/ShoppingCart/Thankyou/DynamicSnippets](https://api.retailys.com/v1#/System.Layouts.Eshop/postEshopShoppingCartThankyouDynamicSnippets) to an API where you can easily try it out.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.retailys.com/examples.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
